<script setup lang="ts">
import { RouterLink } from 'vue-router';
import { ref, type Ref } from 'vue'
import CorpusItem from '@/components/Corpusitems.vue'
import axios from "axios";

import { useCookies } from "vue3-cookies";
import router from "../router/index";
import {
  TransitionRoot,
  TransitionChild,
  Dialog,
  DialogPanel,
  DialogTitle,
} from '@headlessui/vue';

const validAttr = new Set(["title",  "author", "type", "language", "timeWritten", "locationWritten", "media", "ink", "illumination", "desc"])
const isOpen = ref(false)
const backendURL = import.meta.env.VITE_BACKEND_URL;

function closeModal() {
  isOpen.value = false
}
function openModal() {
  isOpen.value = true
}

const { cookies } = useCookies();
let corpusArr: any[] = []
let searchTrue = false
let corpusItems = ref(corpusArr)
let currentCorpus = ref({
  _id: "62626db75cd68f4a7c821a67",
  title: "title",
  author: "author",
  type: "type",
  language: "language",
  timeWritten: "DD-MM-YYYY",
  locationWritten: "location",
  media: "media",
  ink: "ink",
  illumination: "illumination",
  desc: "description",
  idPDF: "-",
  idThumbnail: "9999",
  filePreviewLink: "-",
  thumbnailPreviewLink: "-"

})

let searchItems = async function () {
  corpusItems.value = []
  let queries = (<HTMLInputElement>(document.getElementById('searchInput')))?.value
  if (!queries) {
    searchTrue = false
    loadInitialItems()
    return;
  } else {
    searchTrue = true
  }
  let queriesJson: { [key: string]: string } = {}

  if (queries.includes(":")) {
    const querys = queries.split(/\s*,\s*/)
    for (let i = 0; i < querys.length; i++) {
      let splitted = querys[i].split(/\s*:\s*/)
      if (validAttr.has(splitted[0])) {
        queriesJson[splitted[0]] = splitted[1]
      }
    }
  } else {
    queriesJson["title"] = queries
  }

  await axios.post(`${backendURL}/kitab/search/`, queriesJson
  ).then((response) => {
    for (let index = 0; index < response.data.length; index++) {
      corpusItems.value.push(response.data[index]);
      corpusItems.value[index].index = index;
    }
  }).catch((error) => {
    console.log(error.response.data)
  });
}

let searchNext = async function () {
  let queries = (<HTMLInputElement>(document.getElementById('searchInput')))?.value
  if (!queries) {
    searchTrue = false
    loadMoreItems()
    return;
  } else {
    searchTrue = true
  }
  let queriesJson: { [key: string]: string } = {}
  console.log(searchTrue)
  if (queries.includes(":")) {
    const querys = queries.split(/\s*,\s*/)
    for (let i = 0; i < querys.length; i++) {
      let splitted = querys[i].split(/\s*:\s*/)
      if (validAttr.has(splitted[0])) {
        queriesJson[splitted[0]] = splitted[1]
      }
    }
  } else {
    queriesJson["title"] = queries
  }
  console.log(queriesJson)
  await axios.post(`${backendURL}/kitab/searchNext/` + corpusItems.value[corpusItems.value.length - 1]._id, queriesJson
  ).then((response) => {
    for (let index = 0; index < response.data.length; index++) {
      corpusItems.value.push(response.data[index]);
      corpusItems.value[corpusItems.value.length - 1].index = corpusItems.value.length - 1;
    }
  }).catch((error) => {
    console.log(error)
  });

}

async function loadInitialItems() {
  //load the first 12 corpus, executing getAll()

  try {
    const response = await axios({
      method: "get",
      url: `${backendURL}/kitab/`,
    });
    currentCorpus.value = response.data[0]
    console.log(response.data)
    for (let index = 0; index < response.data.length; index++) {
      corpusItems.value.push(response.data[index]);
      corpusItems.value[index].index = index;
    }
  } catch (err) {
    console.log(err)
  }

}
let loadMoreItems = async function () {
  //load the next 12 corpus from ID, executing getNext(id)
  //get id from corpusItems[-1].id
  await axios.get(`${backendURL}/kitab/getNext/` + corpusItems.value[corpusItems.value.length - 1]._id)
    .then((response) => {
      for (let index = 0; index < response.data.length; index++) {
        corpusItems.value.push(response.data[index]);
        corpusItems.value[corpusItems.value.length - 1].index = corpusItems.value.length - 1;
      }
      console.log(corpusItems.value)
    }).catch((error) => {
      console.log(error.response.data)
    });
}
function changeFocus(index: any) {
  //Execute get(id) and change the elements of current Corpus
  currentCorpus.value = corpusItems.value[index]

}

let deleteCorpus = async function(ids: any){
  await axios({
      method: "delete",
      url: `${backendURL}/kitab/delete/` + ids,
      headers: { 
        "authorization": 'Bearer ' + cookies.get("authorization")
        },
    });
  window.location.reload()
}

loadInitialItems()
</script>

<template>
  <!-- content goes here -->
  <div class="pt-1 text-white flex flex-row justify-center animate__animated animate__fadeIn h-full">
    <div class="flex-1 pt-6 px-6 corpusdetail">
      <RouterLink to="/corpus/create"><button class="navbutton text-white mb-3" v-if="cookies.get('role') === 'Admin'">Tambah Korpus</button></RouterLink>
      <div class="searchbox flex flex-row drop-shadow">
        <img alt="search logo" class="mx-3" src="@/assets/search.svg" width="16" height="16" @click="searchItems()"
          style="cursor:pointer;" />
        <input class="border-l border-neutral-400 px-3 searchinput active:border-0 align-middle grow"
          style="cursor:text;" placeholder="Search" id="searchInput" />
      </div>
      <div class="corpuslist">
        <div class="flex flex-wrap">
          <CorpusItem @click='changeFocus(corpus.index); openModal();' v-for='corpus in corpusItems' :id='corpus.id'
            :imageLink='corpus.thumbnailPreviewLink' :title='corpus.title' :author='corpus.author'
            :language='corpus.language' :description='corpus.desc' />
        </div>
        <button @click="searchNext()" class="navbutton text-white mb-3 mx-auto content-center" style="cursor:pointer;">Muat
          Lebih Banyak</button>
      </div>
    </div>
    <div class="corpusdetail border-l border-neutral-300 flex-1 p-8 md:[min-height:93vh] min-h-screen hidden md:block bg-white">
      <div class="corpusbook">
        <img :src='currentCorpus.thumbnailPreviewLink' alt="Thumbnail" class="bookImage" style="object-fit: cover;">
      </div>
      <h1 class="booktitle mt-3">{{ currentCorpus.title }}</h1>
      <div class="text-sm flex flex-row text-neutral-500 font-medium">
        <h3>{{ currentCorpus.author }},
          {{ currentCorpus.type }},
          {{ currentCorpus.language }},
          {{ currentCorpus.media }},
          {{ currentCorpus.ink }},
          {{ currentCorpus.illumination }}</h3>
      </div>
      <p id="description" class="text-base text-black font-normal border-t border-neutral-400 p-1">{{ currentCorpus.desc
      }}</p>

      <div v-if="cookies.get('role') === 'Member' || cookies.get('role') === 'Admin'" class="flex flex-row">

        <a :href = 'currentCorpus.filePreviewLink' target="_blank" id="readpdf" class="navbutton text-white pt-1" style="cursor:pointer;">Baca Korpus</a>
        
          <RouterLink :to="`/corpus/update/${currentCorpus._id}`"><button v-if="cookies.get('role') === 'Admin'" id="updatepdf" class="navbutton text-white" style="cursor:pointer;">Update Korpus</button></RouterLink>
          <button @click="deleteCorpus(currentCorpus._id)" v-if="cookies.get('role') === 'Admin'" class="navbutton text-white" style="cursor:pointer;">Hapus Korpus</button>
        
      </div>
      <TransitionRoot appear :show="isOpen" as="template">
        <Dialog as="div" @close="closeModal" class="relative z-10 min md:hidden w-full">
          <TransitionChild as="template" enter="duration-300 ease-out" enter-from="opacity-0" enter-to="opacity-100"
            leave="duration-200 ease-in" leave-from="opacity-100" leave-to="opacity-0">
            <div class="fixed inset-0 bg-black bg-opacity-25" />
          </TransitionChild>

          <div class="fixed inset-0 overflow-y-auto">
            <div class="flex min-h-full min-w-full items-center justify-center p-4 text-center">
              <TransitionChild as="template" enter="duration-300 ease-out" enter-from="opacity-0 scale-95"
                enter-to="opacity-100 scale-100" leave="duration-200 ease-in" leave-from="opacity-100 scale-100"
                leave-to="opacity-0 scale-95">
                <DialogPanel
                  class="w-full max-w-md transform overflow-hidden rounded-2xl bg-white p-6 text-left align-middle shadow-xl transition-all">
                  <DialogTitle as="h3" class="booktitle mb-3">
                    {{ currentCorpus.title }}
                  </DialogTitle>
                  <div class="corpusbook">
                    <img :src='currentCorpus.thumbnailPreviewLink' alt="Thumbnail" class="bookImage" style="object-fit: cover;">
                  </div>
                  <div class="text-sm flex flex-row text-neutral-500 font-medium">
                    <h3>{{ currentCorpus.author }},
                      {{ currentCorpus.type }},
                      {{ currentCorpus.language }},
                      {{ currentCorpus.media }},
                      {{ currentCorpus.ink }},
                      {{ currentCorpus.illumination }}</h3>
                  </div>
                  <p class="text-base text-black font-normal border-t border-neutral-400 p-1">
                    {{currentCorpus.desc}}
                  </p>

                  <div v-if="cookies.get('role') === 'Member' || cookies.get('role') === 'Admin'" class="flex flex-row">

                  <a :href = 'currentCorpus.filePreviewLink' target="_blank" id="readpdf" class="navbutton text-white pt-1" style="cursor:pointer;">Baca Korpus</a>
                  <RouterLink :to="`/corpus/update/${currentCorpus._id}`"><button v-if="cookies.get('role') === 'Admin'" id="updatepdf" class="navbutton text-white" style="cursor:pointer;">Update Korpus</button></RouterLink>
                  <button @click="deleteCorpus(currentCorpus._id)" v-if="cookies.get('role') === 'Admin'" class="navbutton text-white" style="cursor:pointer;">Hapus Korpus</button>
                  </div>
                </DialogPanel>
              </TransitionChild>
            </div>
          </div>
        </Dialog>
      </TransitionRoot>

    </div>
  </div>
</template>

<style>
.bookImage {
  @apply min-w-full;
  object-fit: cover;
}

.corpuslist {
  @apply overflow-y-auto mt-1;
  scroll-behavior: smooth;
  height: 83%;
}

.corpusbook {
  @apply flex-auto min-w-full h-72 border border-neutral-300 drop-shadow-xl overflow-hidden;
  background: #d6dcd6;
  border-radius: 15px;
}

.corpusdetail {
  @apply overflow-y-auto;
}

.booktitle {
  @apply text-5xl text-neutral-600 font-medium mb-3;
}

.navbutton {
  max-width: 10rem;
  min-height: 2rem;
  border-radius: 15px;
  background-color: #3ED692 !important;
  @apply mt-3 mr-1 px-2 hover:bg-emerald-500 !important;
}

.delbutton {
  max-width: 10rem;
  min-height: 2rem;
  background: #821a28;
  border-radius: 15px;
  @apply mt-3 mr-1 px-2 hover:bg-rose-700;
}

.searchinput {
  width: 5rem;
  background: transparent;
  @apply text-black !important;
}

.searchbox {
  background: #ffffff !important;
  max-width: 50%;
  height: 2rem;
  border-radius: 15px;
}
</style>
